#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl

package dns;

push(@INC, "/opt/novell/xad/lib64/perl", "/opt/novell/xad/lib/perl");

use XAD::registry;
use XAD::ntds;
use XAD::dclib;
use warnings;
no warnings 'void';
#use strict;

my %RR_Types_maps = (
	"A"		=> "1",
	"NS"		=> "2",
	"CNAME"		=> "5",
	"PTR"		=> "12",
	"SRV"		=> "33"
	);

my ($finalbitstring, $finalbase64string, $rc, $data_len) = "";
my $debug = 0;
my ($finaldatastring, $datapackstring) = "";
my (@data_array, @data_member_length) = "";

# process the Resource Record
sub Generate_Ldif_4_Delegate_Zone {
	my ($Record_Name, $Finalbase64String_A, $Finalbase64String_NS, $Zone, $FRDZONE_CONTEXT, $Is_ADC, $Action) = @_;
	chomp $Record_Name;
	my $Record_Ldif_name = "";
	if($Action eq "add") {
		$Record_Ldif_name = "/var/opt/novell/xad/ds/dns/RR/$Record_Name"."_Delegate.ldif";
	} elsif($Action eq "delete") {
		$Record_Ldif_name = "/var/opt/novell/xad/ds/dns/RR/Delete_"."$Record_Name"."_Delegate.ldif";
	}

	open(OLDOUT, ">&STDOUT");
	open(STDOUT, "+>$Record_Ldif_name") || die "cannot open $Record_Ldif_name: $!";
	my $cn = $Record_Name;
	$cn =~ s/_/\#/g;
	$cn =~ s/\./_/g;
	my $Record_DN = "cn=$cn,"."$FRDZONE_CONTEXT";
	my $dNIPDNSDomainName = "";
	$dNIPDNSDomainName = "$Zone";

	# printing the ldif now
	if($Is_ADC eq "FALSE") 	{
			if($Action eq "add") {
				print "dn: $Record_DN\n";
				print "changetype: add\n";
				print "dNIPRRStatus: 0\n";
				print "dNIPRR:: $Finalbase64String_A\n";
				print "dNIPRR:: $Finalbase64String_NS\n";
				print "dNIPRRSetOptions: 0\n";
				print "dNIPDNSDomainName: $dNIPDNSDomainName\n";
				print "objectClass: dNIPDNSRRset\n";
				print "objectClass: Top\n";
				print "cn: $cn\n";
			}
	} elsif($Is_ADC eq "TRUE") {
		if($Action eq "add") {
			print "dn: $Record_DN\n";
			print "changetype: modify\n";
			print "add: dNIPRR\n";
			print "dNIPRR:: $Finalbase64String_A\n";
		} elsif($Action eq "delete") {
			print "dn: $Record_DN\n";
			print "changetype: modify\n";
			print "delete: dNIPRR\n";
			print "dNIPRR:: $Finalbase64String_A\n";
		}
	}
	close(STDOUT);
	open(STDOUT, ">&OLDOUT");
	print "End of writing the ldif file: $Record_Ldif_name\n" if $debug;
}


sub Process_delegate_RR {

	my ($my_domain_node, $my_domain_ip, $FRDZONE_CONTEXT, $IPFlg, $Is_ADC, $Action) = @_;
	#flush the value of strings
	($finalbitstring_NS, $finalbase64string_NS) = "";
	($finalbitstring_A, $finalbase64string_A, $rc, $data_len) = "";


	my $InstallMachineName = `/opt/novell/xad/share/dcinit/printConfigKey.pl "InstallMachineName" | tr "[:upper:]" "[:lower:]"`;
	chomp $InstallMachineName;
	print "InstallMachineName :$InstallMachineName\n" if $debug;
	my $Zone_name = "";
	if($IPFlg == 1) {
		$Zone_name = `/opt/novell/xad/share/dcinit/printConfigKey.pl "IP_ADDRESS_UNDERSCORE_FORM"`;
		chomp $Zone_name;
		$Zone_name =~ s/_/\./g; #replace all _ to .
	} else {
		$Zone_name = `/opt/novell/xad/share/dcinit/printConfigKey.pl "DNS Host Name"`;
		chomp $Zone_name;
		$Zone_name =substr($Zone_name, (length($InstallMachineName) + 1), length($Zone_name));
	}
	print "Zone_name: $Zone_name\n" if $debug;


	my %RR_value_A = (
		"RR_Type"	=> "1",
		"RR_Adr_Class"	=> "1",
		"RR_TTL"	=> "0",
		"RR_Data_len"	=> ""
		);

	my %A_Data_Value = (
		"Priority"	=> "0",
		"Weight"	=> "0",
		"Port"		=> "0",
		"Data"		=> "0"
	);

	$A_Data_Value{Data} = "$my_domain_ip";

	$RR_value_A{RR_Data_len} = 4;

	# get the base64 strings for final bit string
	my $IP_len = length($A_Data_Value{Data});
	$finalbitstring_A = pack "nnNnC4", $RR_value_A{RR_Type}, $RR_value_A{RR_Adr_Class}, $RR_value_A{RR_TTL}, $RR_value_A{RR_Data_len}, split(/\./, "$A_Data_Value{Data}");

	$finalbase64string_A = XAD::encodeBase64($finalbitstring_A);

	#
	# NS DATA Record Section
	#
	my %RR_value_NS = (
		"RR_Type"	=> "2",
		"RR_Adr_Class"	=> "1",
		"RR_TTL"	=> "0",
		"RR_Data_len"	=> ""
	);
	my %NS_Data_Value = (
		"Priority"	=> "0",
		"Weight"	=> "0",
		"Port"		=> "0",
		"Data"		=> "0"
	);

	$NS_Data_Value{Data} = registry::getReg("FWDZONE_DNSMASTER");

	# compute the data length and put that in the hash in bytes
	my $temp_data_string = "";

	# generate the data string
	Form_Data_format($NS_Data_Value{Data});

	$temp_data_string = $final_data_string;
	$temp_data_string =~ s/,//g;

	# data length needs to be computed, where data string is in format
	# of '7melanin3bug3org'
	$data_len = length($temp_data_string);

	# for 1 byte of null padding at the end + data length computed
	$RR_value_NS{RR_Data_len} =  $data_len + 1;

	my $finalpackstring = "";
	# get the pack string for NS type records
	$finalpackstring = "nnNn";
	# append the computed pack string to create the actual pack string
	$finalpackstring .= "$datapackstring";
	# append the null byte pack string at the end
	$finalpackstring .= "x";

	# now get the final bit string for the NS type records
	$finalbitstring_NS = pack "$finalpackstring", $RR_value_NS{RR_Type}, $RR_value_NS{RR_Adr_Class}, $RR_value_NS{RR_TTL}, $RR_value_NS{RR_Data_len}, split(",", "$final_data_string");
	$finalbase64string_NS = XAD::encodeBase64($finalbitstring_NS);

	# generate the ldif for record
	my $Record_name = $my_domain_node;
	Generate_Ldif_4_Delegate_Zone($Record_name, $finalbase64string_A, $finalbase64string_NS, "$Zone_name", "$FRDZONE_CONTEXT", "$Is_ADC", "$Action");
}


sub Process_RR {

	#Using 'IN' as the seperator
	my ($RRString, $IPFlg, $DNSZONE_CONTEXT, $Is_ADC, $Action) = @_;
	#flush the value of strings
	($finalbitstring, $finalbase64string, $rc, $data_len) = "";
	$RRString =~ s/\s+/ /g;
	my @RRString_array_temp =split("IN ",$RRString);
	my @RRString_array = split(" ", $RRString_array_temp[1]);
	print "array contains : @RRString_array\n" if $debug;
	# the array would be having following structure
	# ary[0] = record type
	# ary[1] = priority
	# ary[2] = weight
	# ary[3] = machine details
	#create the hash accordingly
	my %RR_value = (
		"RR_Type"	=> "$RR_Types_maps{$RRString_array[0]}",
		"RR_Adr_Class"	=> "1",
		"RR_TTL"	=> "0",
		"RR_Data_len"	=> ""
		);

	my %RR_Data_Value = (
	"Priority"	=> "0",
	"Weight"	=> "0",
	"Port"		=> "0",
	"Data"		=> "0"
	);

	# fill the value of priority, weight and data on the basis of
	# RR type
	if($RRString_array[0] eq "SRV")
	{
		$RR_Data_Value{Priority} = "$RRString_array[1]";
		$RR_Data_Value{Weight} = "$RRString_array[2]";
		$RR_Data_Value{Port} = "$RRString_array[3]";
		$RR_Data_Value{Data} = "$RRString_array[4]";
	}
	else
	{
		$RR_Data_Value{Data} = "$RRString_array[1]";
	}

	# compute the data length and put that in the hash,
	# in bytes
	my $temp_data_string = "";

	if($RRString_array[0] eq "SRV")
	{
	# generate the data string
	Form_Data_format($RR_Data_Value{Data});

	$temp_data_string = $final_data_string;
	$temp_data_string =~ s/,//g;

	# data length needs to be computed, where data string is in format
	# of '7melanin3bug3org'
	@data_array = split(/,/, $final_data_string);
	$data_len = 0;
	for($i=0; $i<@data_array; $i+=2)
	{
		#lenth of each word between dots
		$data_len += int($data_array[$i]);
	}
	#one byte to store each word's length
	$data_len += (@data_array)/2;

	# data length = 2 bytes (priority) + 2 byte (weight) + 2 byte (port) +  length(data) in bytes + 1 byte (null char), as the 1 byte of 1st data segment is counted in $data_len now
	$RR_value{RR_Data_len} =  2 + 2 + 2 +  "$data_len" + 1;

	}
	elsif(($RRString_array[0] eq "NS") || ($RRString_array[0] eq "CNAME") || ($RRString_array[0] eq "PTR"))
	{
		# generate the data string
		Form_Data_format($RR_Data_Value{Data});

		$temp_data_string = $final_data_string;
		$temp_data_string =~ s/,//g;

		# data length needs to be computed, where data string is in format
		# of '7melanin3bug3org'
		$data_len = length($temp_data_string);

		# for 1 byte of null padding at the end + data length computed
		$RR_value{RR_Data_len} =  $data_len + 1;
	}
	else
	{
		# its a 'A' type record
		$RR_value{RR_Data_len} = 4;
	}

	# get the base64 strings for final bit string
	my $finalpackstring = "";

	# only for SRV type records and data field only for other records
	if($RRString_array[0] eq "SRV")
	{
		# get the pack string for SRV type records
		$finalpackstring = "nnNnnnn";
		# append the computed pack string to create the actual pack string
		$finalpackstring .= "$datapackstring";
		# append the null byte pack string at the end
		$finalpackstring .= "x";

		# now get the final bit string fro the SRV type records

		$finalbitstring = pack "$finalpackstring", $RR_value{RR_Type}, $RR_value{RR_Adr_Class}, $RR_value{RR_TTL}, $RR_value{RR_Data_len}, $RR_Data_Value{Priority}, $RR_Data_Value{Weight}, $RR_Data_Value{Port}, split(",", "$final_data_string");
	}
	elsif($RRString_array[0] eq "A")
	{
		my $IP_len = length($RR_Data_Value{Data});
		$finalbitstring = pack "nnNnC4", $RR_value{RR_Type}, $RR_value{RR_Adr_Class}, $RR_value{RR_TTL}, $RR_value{RR_Data_len}, split(/\./, "$RR_Data_Value{Data}");
	}
	elsif($RRString_array[0] eq "CNAME")
	{

		# get the pack string for CNAME type records
		$finalpackstring = "nnNn";
		# append the computed pack string to create the actual pack string
		$finalpackstring .= "$datapackstring";
		# append the null byte pack string at the end
		$finalpackstring .= "x";

		# now get the final bit string fro the CNAME type records
		$finalbitstring = pack "$finalpackstring", $RR_value{RR_Type}, $RR_value{RR_Adr_Class}, $RR_value{RR_TTL}, $RR_value{RR_Data_len}, split(",", "$final_data_string");
	}
	elsif(($RRString_array[0] eq "NS") || ($RRString_array[0] eq "PTR"))
	{
		# get the pack string for NS type records
		$finalpackstring = "nnNn";
		# append the computed pack string to create the actual pack string
		$finalpackstring .= "$datapackstring";
		# append the null byte pack string at the end
		$finalpackstring .= "x";

		# now get the final bit string for the NS type records

		$finalbitstring = pack "$finalpackstring", $RR_value{RR_Type}, $RR_value{RR_Adr_Class}, $RR_value{RR_TTL}, $RR_value{RR_Data_len}, split(",", "$final_data_string");
	}

	print "finalbitstring: $finalbitstring\n" if $debug;

	# get the base64 string for the $finalbitstring
	$finalbase64string = XAD::encodeBase64($finalbitstring);
	print "finalbase64string : $finalbase64string\n" if $debug;

	# generate the ldif for record
	my $Record_name = $RRString_array_temp[0];

	my $InstallMachineName = `/opt/novell/xad/share/dcinit/printConfigKey.pl "InstallMachineName" | tr "[:upper:]" "[:lower:]"`;
	chomp $InstallMachineName;
	print "InstallMachineName :$InstallMachineName\n" if $debug;
	my $Zone_name = "";
	if($IPFlg == 1)
	{
		$Zone_name = `/opt/novell/xad/share/dcinit/printConfigKey.pl "IP_ADDRESS_UNDERSCORE_FORM"`;
		chomp $Zone_name;
		$Zone_name =~ s/_/\./g; #replace all _ to .
	}
	else
	{
		$Zone_name = `/opt/novell/xad/share/dcinit/printConfigKey.pl "DNS Host Name"`;
		chomp $Zone_name;
		$Zone_name =substr($Zone_name, (length($InstallMachineName) + 1), length($Zone_name));
	}
	print "Zone_name: $Zone_name\n" if $debug;
	my $RRString_first_element = $RRString_array_temp[0];
	$RRString_first_element =~ s/\s+//g;

	if($RRString_array[0] eq "SRV")
	{
		Generate_Ldif_4_SRV_Records($Record_name, $finalbase64string, "$Zone_name", "$DNSZONE_CONTEXT", "$Is_ADC", "$Action");
	}
	if($RRString_array[0] eq "A")
	{
		if($RRString_first_element =~ /^$InstallMachineName/)
		{
			$Record_name = "$InstallMachineName";
			# pass the Is_ADC flg as FALSE by default
			Generate_Ldif_4_AType_records($Record_name, $finalbase64string, "$Zone_name", "$DNSZONE_CONTEXT", "FALSE", "$Action");
		}
		else
		{
			# its an A type entry for the zone
			Generate_Ldif_4_AType_records("\@", $finalbase64string, "$Zone_name", "$DNSZONE_CONTEXT", "$Is_ADC", "$Action");
		}
	}
	if($RRString_array[0] eq "CNAME")
	{
		$Record_name = $RRString_array_temp[0];
		Generate_Ldif_4_CNAMEType_records($Record_name, $finalbase64string, "$Zone_name", "$DNSZONE_CONTEXT", "$Action");
	}
	if($RRString_array[0] eq "NS")
	{
		#$Record_name = "NS_"."$RR_Data_Value{Data}";
		Generate_Ldif_4_NSType_records("\@", $finalbase64string, "$Zone_name", "$DNSZONE_CONTEXT", "$Action");
	}
	if($RRString_array[0] eq "PTR")
	{
		if($RRString_first_element ne "" && $RRString_first_element =~ /\d*\.*\d*\.*\d*/)
		{
			#Its normal PTR record
			Generate_Ldif_4_PTRType_records($Record_name, $finalbase64string, "$Zone_name", "$DNSZONE_CONTEXT", "$Action");
		}
		else
		{
			#Its PTR record for the reverse zone itself
			Generate_Ldif_4_PTRType_records("\@", $finalbase64string, "$Zone_name", "$DNSZONE_CONTEXT", "$Action");
		}
	}

}

sub Generate_Ldif_4_SRV_Records {
	my ($Record_Name, $Base64_RR_value, $Zone, $DNSZONE_CONTEXT, $Is_ADC, $Action) = @_;
	my $MachineGUID_Record = 0;
	chomp $Record_Name;
	#$Record_Name =~ s/\.//g;
	$Record_Name =~ s/\s+//g;
	my $Record_Ldif_Name = "";
	if($Action eq "delete")
	{
		$Record_Ldif_Name = "/var/opt/novell/xad/ds/dns/RR/"."Delete_"."$Record_Name.ldif";
	}
	elsif($Action eq "add")
	{
		$Record_Ldif_Name = "/var/opt/novell/xad/ds/dns/RR/$Record_Name.ldif";
	}
	open(OLDOUT, ">&STDOUT");
	open(STDOUT, "+>$Record_Ldif_Name") || die "cannot open $Record_Ldif_Name:$!";
	my $Zone_name_with_underscores = $Zone;
	$Zone_name_with_underscores =~ s/\./_/g;
	my $NDSTempContainerDN = `/opt/novell/xad/share/dcinit/printConfigKey.pl "Mapped NDS Temp Container"`;
	chomp $NDSTempContainerDN;
	my $Record_name_with_underscore = $Record_Name;
	$Record_name_with_underscore =~ s/\./_/g;
	my $cn = $Record_Name;
	$cn =~ s/_/\#/g;
	$cn =~ s/\./_/g;
	# if($Record_name_with_underscore =~ /domains/)
	# {
	# 	# set the MachineGUID_Record flg
	# 	$MachineGUID_Record = 1;
	# }

	#my $Record_DN = "cn=\\$cn,"."cn=$Zone_name_with_underscores,"."$NDSTempContainerDN";
	my $Record_DN = "cn=\\$cn,"."cn=$Zone_name_with_underscores,"."$DNSZONE_CONTEXT";
	my $dNIPDNSDomainName = "$Record_Name";
	$dNIPDNSDomainName .= ".$Zone";

	# print the ldif now
	if($Is_ADC eq "FALSE")
	{
		print "dn: $Record_DN\n";
		print "changetype: add\n";
		print "dNIPRRStatus: 0\n";
		print "dNIPRR:: $Base64_RR_value\n";
		print "dNIPDNSDomainName: $dNIPDNSDomainName\n";
		print "objectClass: dNIPDNSRRset\n";
		print "objectClass: Top\n";
		print "cn: $cn\n";
	}
	elsif($Is_ADC eq "TRUE")
	{
		# if($MachineGUID_Record)
		# {
		# 	if($Action eq "delete")
		# 	{
		# 		print "dn: $Record_DN\n";
		# 		print "changetype: delete\n";
		# 	}
		# 	elsif($Action eq "add")
		# 	{
		# 		print "dn: $Record_DN\n";
		# 		print "changetype: add\n";
		# 		print "dNIPRRStatus: 0\n";
		# 		print "dNIPRR:: $Base64_RR_value\n";
		# 		print "dNIPDNSDomainName: $dNIPDNSDomainName\n";
		# 		print "objectClass: dNIPDNSRRset\n";
		# 		print "objectClass: Top\n";
		# 		print "cn: $cn\n";
		# 	}
		# }
		# else
		# {
			if($Action eq "delete")
			{
				print "dn: $Record_DN\n";
				print "changetype: modify\n";
				print "delete:  dNIPRR\n";
				print "dNIPRR:: $Base64_RR_value\n";
			}
			elsif($Action eq "add")
			{
				print "dn: $Record_DN\n";
				print "changetype: modify\n";
				print "add: dNIPRR\n";
				print "dNIPRR:: $Base64_RR_value\n";
			}
		# }
	}

	close(STDOUT);
	open(STDOUT, ">&OLDOUT");
	print "End of writing the ldif file: $Record_Ldif_Name\n" if $debug;
}


sub Generate_Ldif_4_AType_records {
	my ($Record_Name, $Finalbase64String, $Zone, $DNSZONE_CONTEXT, $Is_ADC, $Action) = @_;
	chomp $Record_Name;
	my $Record_Ldif_name = "";
	if ($Record_Name eq "\@")
	{
		if($Action eq "add")
		{
			$Record_Ldif_name = "/var/opt/novell/xad/ds/dns/RR/"."$Record_Name"."_"."A"."$Zone".".ldif";
		}
		elsif($Action eq "delete")
		{
			$Record_Ldif_name = "/var/opt/novell/xad/ds/dns/RR/"."Delete_"."$Record_Name"."_"."A"."$Zone".".ldif";
		}
	}
	else
	{
		if($Action eq "add")
		{
			$Record_Ldif_name = "/var/opt/novell/xad/ds/dns/RR/"."$Record_Name"."_"."$Zone".".ldif";
		}
		elsif($Action eq "delete")
		{
			$Record_Ldif_name = "/var/opt/novell/xad/ds/dns/RR/Delete_"."$Record_Name"."_"."$Zone".".ldif";
		}
	}
	open(OLDOUT, ">&STDOUT");
	open(STDOUT, "+>$Record_Ldif_name") || die "cannot open $Record_Ldif_name: $!";
	my $NDSTempContainerDN = `/opt/novell/xad/share/dcinit/printConfigKey.pl "Mapped NDS Temp Container"`;
	chomp $NDSTempContainerDN;
	my $Zone_name_with_underscores = $Zone;
	$Zone_name_with_underscores =~ s/\./_/g;
	my $cn = $Record_Name;
	$cn =~ s/_/\#/g;
	$cn =~ s/\./_/g;
	#my $Record_DN = "cn=$cn,"."cn=$Zone_name_with_underscores,"."$NDSTempContainerDN";
	my $Record_DN = "cn=$cn,"."cn=$Zone_name_with_underscores,"."$DNSZONE_CONTEXT";
	my $dNIPDNSDomainName = "";
	if ($Record_Name eq "\@")
	{
		$dNIPDNSDomainName = "$Zone";
	}
	else
	{
		$dNIPDNSDomainName = "$Record_Name."."$Zone";
	}

	# printing the ldif now
	if($Is_ADC eq "FALSE")
	{
		if($Record_Name eq "\@")
		{
			if($Action eq "add")
			{
				print "dn: $Record_DN\n";
				print "changetype: modify\n";
				print "add: dNIPRR\n";
				print "dNIPRR:: $Finalbase64String\n";
			}
			elsif($Action eq "delete")
			{
				print "changetype: modify\n";
				print "delete: dNIPRR\n";
				print "dNIPRR:: $Finalbase64String\n";
			}
		}
		else
		{
			if($Action eq "add")
			{
				print "dn: $Record_DN\n";
				print "changetype: add\n";
				print "dNIPRRStatus: 0\n";
				print "dNIPRR:: $Finalbase64String\n";
				print "dNIPRRSetOptions: 0\n";
				print "dNIPDNSDomainName: $dNIPDNSDomainName\n";
				print "objectClass: dNIPDNSRRset\n";
				print "objectClass: Top\n";
				print "cn: $cn\n";
			}
			elsif($Action eq "delete")
			{
				print "dn: $Record_DN\n";
				print "changetype: delete\n";
			}
		}
	}
	elsif($Is_ADC eq "TRUE")
	{
		if($Action eq "add")
		{
			print "dn: $Record_DN\n";
			print "changetype: modify\n";
			print "add: dNIPRR\n";
			print "dNIPRR:: $Finalbase64String\n";
		}
		elsif($Action eq "delete")
		{
			print "dn: $Record_DN\n";
			print "changetype: modify\n";
			print "delete: dNIPRR\n";
			print "dNIPRR:: $Finalbase64String\n";
		}
	}
	close(STDOUT);
	open(STDOUT, ">&OLDOUT");
	print "End of writing the ldif file: $Record_Ldif_name\n" if $debug;
}

sub Generate_Ldif_4_CNAMEType_records {
	my ($Record_Name, $Finalbase64String, $Zone, $DNSZONE_CONTEXT, $Action) = @_;
	chomp $Record_Name;
	$Record_Name =~ s/\s+//g;
	my $Record_Ldif_name = "";
	if ($Action eq "add")
	{
		$Record_Ldif_name = "/var/opt/novell/xad/ds/dns/RR/"."$Record_Name"."_"."$Zone".".ldif";
	}
	elsif($Action eq "delete")
	{
		$Record_Ldif_name = "/var/opt/novell/xad/ds/dns/RR/Delete_"."$Record_Name"."_"."$Zone".".ldif";
	}
	open(OLDOUT, ">&STDOUT");
	open(STDOUT, "+>$Record_Ldif_name") || die "cannot open $Record_Ldif_name:$!";
	my $NDSTempContainerDN = `/opt/novell/xad/share/dcinit/printConfigKey.pl "Mapped NDS Temp Container"`;
	chomp $NDSTempContainerDN;
	my $Zone_name_with_underscores = $Zone;
	$Zone_name_with_underscores =~ s/\./_/g;
	my $Record_name_with_underscore = $Record_Name;
	$Record_name_with_underscore =~ s/\./_/g;
	my $cn = $Record_Name;
	$cn =~ s/_/\#/g;
	$cn =~ s/\./_/g;
	#my $Record_DN = "cn=$cn,"."cn=$Zone_name_with_underscores,"."$NDSTempContainerDN";
	my $Record_DN = "cn=$cn,"."cn=$Zone_name_with_underscores,"."$DNSZONE_CONTEXT";
	my $dNIPDNSDomainName = "$Record_Name."."$Zone";

	# printing the ldif now
	if($Action eq "add")
	{
		print "dn: $Record_DN\n";
		print "changetype: add\n";
		print "dNIPRRStatus: 0\n";
		print "dNIPRR:: $Finalbase64String\n";
		print "dNIPRRSetOptions: 0\n";
		print "dNIPDNSDomainName: $dNIPDNSDomainName\n";
		print "objectClass: dNIPDNSRRset\n";
		print "objectClass: Top\n";
		print "cn: $cn\n";
	}
	elsif($Action eq "delete")
	{
		print "dn: $Record_DN\n";
		print "changetype: delete\n";
	}

	close(STDOUT);
	open(STDOUT, ">&OLDOUT");
	print "End of writing the ldif file: $Record_Ldif_name\n" if $debug;
}

sub Generate_Ldif_4_NSType_records {
	my ($Record_Name, $Finalbase64String, $Zone, $DNSZONE_CONTEXT, $Action) = @_;
	chomp $Record_Name;
	$Record_Name =~ s/\s+//g;
	my $Record_Ldif_name = "";
	my $Record_Ldif_update_name = "";
	if($Action eq "add")
	{
		$Record_Ldif_name = "/var/opt/novell/xad/ds/dns/RR/"."$Record_Name"."_NS"."_"."$Zone".".ldif";
		$Record_Ldif_update_name = "/var/opt/novell/xad/ds/dns/RR/"."$Record_Name"."_NS"."_update_"."$Zone".".ldif";
	}
	elsif($Action eq "delete")
	{
		$Record_Ldif_name = "/var/opt/novell/xad/ds/dns/RR/Delete_"."$Record_Name"."_NS"."_"."$Zone".".ldif";
	}
	open(OLDOUT, ">&STDOUT");
	open(STDOUT, "+>$Record_Ldif_name") || die "cannot open $Record_Ldif_name:$!";
	my $NDSTempContainerDN = `/opt/novell/xad/share/dcinit/printConfigKey.pl "Mapped NDS Temp Container"`;
	chomp $NDSTempContainerDN;
	my $Zone_name_with_underscores = $Zone;
	$Zone_name_with_underscores =~ s/\./_/g;
	my $Record_name_with_underscore = $Record_Name;
	$Record_name_with_underscore =~ s/\./_/g;
	my $cn = $Record_Name;
	$cn =~ s/_/\#/g;
	$cn =~ s/\./_/g;
	#my $Record_DN = "cn=$cn,"."cn=$Zone_name_with_underscores,"."$NDSTempContainerDN";
	my $Record_DN = "cn=$cn,"."cn=$Zone_name_with_underscores,"."$DNSZONE_CONTEXT";
	my $dNIPDNSDomainName = "$Zone";

	# printing the ldif now
	print "dn: $Record_DN\n";
	if($Action eq "add")
	{
		print "changetype: add\n";
		print "dNIPRRStatus: 0\n";
		print "dNIPRRSetOptions: 0\n";
		print "dNIPDNSDomainName: $dNIPDNSDomainName\n";
		print "objectClass: dNIPDNSRRset\n";
		print "objectClass: Top\n";
		print "cn: $cn\n";
		close(STDOUT);

		#Now we try to create the '@' object with the above ldif entry.
		#Add the rr record using below ldif. If pdc both the ldif will succeed.
		#If adc (on same subnet) first ldif will fail with duplicate entry.Second ldif will pass.
		#if adc (on different subnet) both the ldif will succeed
		open(STDOUT, "+>$Record_Ldif_update_name");
		print "\ndn: $Record_DN\n";
		print "changetype: modify\n";
		print "add: dNIPRR\n";
		print "dNIPRR:: $Finalbase64String\n";
	}
	elsif($Action eq "delete")
	{
			print "changetype: modify\n";
			print "delete: dNIPRR\n";
			print "dNIPRR:: $Finalbase64String\n";
	}

	close(STDOUT);
	open(STDOUT, ">&OLDOUT");
	print "End of writing the ldif file: $Record_Ldif_name\n" if $debug;
}

sub Generate_Ldif_4_PTRType_records {

	my ($Record_Name, $Finalbase64String, $Zone, $DNSZONE_CONTEXT, $Action) = @_;
	chomp $Record_Name;
	$Record_Name =~ s/\s+//g;
	my $Record_Ldif_name = "";
	if($Action eq "add")
	{
		$Record_Ldif_name = "/var/opt/novell/xad/ds/dns/RR/"."$Record_Name"."_APTR"."_"."$Zone".".ldif";
	}
	elsif($Action eq "delete")
	{
		$Record_Ldif_name = "/var/opt/novell/xad/ds/dns/RR/Delete_"."$Record_Name"."_APTR"."_"."$Zone".".ldif";
	}

	open(OLDOUT, ">&STDOUT");
	open(STDOUT, "+>$Record_Ldif_name") || die "cannot open $Record_Ldif_name:$!";
	my $NDSTempContainerDN = `/opt/novell/xad/share/dcinit/printConfigKey.pl "Mapped NDS Temp Container"`;
	chomp $NDSTempContainerDN;
	my $Zone_name_with_underscores = $Zone;
	$Zone_name_with_underscores =~ s/\./_/g;
	my $Record_name_with_underscore = $Record_Name;
	$Record_name_with_underscore =~ s/\./_/g;
	my $cn = $Record_Name;
	$cn =~ s/_/\#/g;
	$cn =~ s/\./_/g;
	#my $Record_DN = "cn=$cn,"."cn=$Zone_name_with_underscores,"."$NDSTempContainerDN";
	my $Record_DN = "cn=$cn,"."cn=$Zone_name_with_underscores,"."$DNSZONE_CONTEXT";
	my $dNIPDNSDomainName = $Zone;

	#It should be the full reverse address, in case of a PTR record for IP address
	if($Record_Name =~ /^\d+/) {
		$dNIPDNSDomainName = "$Record_Name.$Zone";
	}

	# printing the ldif now
	if($Action eq "add")
	{
		print "dn: $Record_DN\n";
		print "changetype: add\n";
		print "dNIPRRStatus: 0\n";
		print "dNIPRR:: $Finalbase64String\n";
		print "dNIPRRSetOptions: 0\n";
		print "dNIPDNSDomainName: $dNIPDNSDomainName\n";
		print "objectClass: dNIPDNSRRset\n";
		print "objectClass: Top\n";
		print "cn: $cn\n";
	}
	elsif($Action eq "delete")
	{
		print "dn: $Record_DN\n";
		print "changetype: delete\n";
	}

	close(STDOUT);
	open(STDOUT, ">&OLDOUT");
	print "End of writing the ldif file: $Record_Ldif_name\n" if $debug;
}

sub Form_Data_format {
	my ($data_string) = @_;
	my (@data_array, @data_member_length, @aggregate_array) = "";
	my ($data_array_length, $i, $j) = 0;

	$data_string =~ s/\./_/g;
	@data_array = split("_", $data_string);
	$data_array_length = @data_array;
	$datapackstring = "ca";

	for($i=0; $i < $data_array_length; $i++)
	{
		$data_member_length[$i] = length($data_array[$i]);
		$datapackstring .= length($data_array[$i])."ca";
	}

	# chop off the last two added 'ca' to datapackstring
	chop $datapackstring;
	chop $datapackstring;

	print "\ndata_member_length array :@data_member_length" if $debug;

	for($i=0, $j=0;(($i< $data_array_length), ($j< ($data_array_length*2)));$i++, $j=$j+2)
	{
		$aggregate_array[$j] = $data_member_length[$i];
		$aggregate_array[$j+1] = $data_array[$i];
	}
	# create the final data string
	$final_data_string = join(',', @aggregate_array);
	print "\n aggregate_array :@aggregate_array\n" if $debug;
	print "\nfinal_data_string: $final_data_string\n" if $debug;
	print "\ndatapackstring: $datapackstring\n" if $debug;
}

sub reverseipAddress {

	my ($ip) = @_;
	my (@ip, $rev, @rev);

	@ip = split /\./, $ip;
	@rev = reverse @ip;
	$rev = join ('.', @rev);

	return $rev;
}

1;

