#!/usr/bin/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2004
#	Novell, Inc.  All rights reserved.
################################################################################
#
#   NAME:
#         replib.pl
#
#   FACILITY:
#
#         Domain Controller Replication Provisioning Tool
#
#   ABSTRACT:
#
#         This module is responsible for the configuration defaults of a
#         replicated domain.
#
#   REVISION:
#
#         $Id$
#
#################################################################################

package XAD;

use XAD::registry;

my $rcsId = '$Id$';

sub getRemoteConfiguration
{
	my ($host) = @_;
	my %dcProvInfo;
	my $PROVISION;

	$PROVISION = defined($REGISTRY{"Prefix"}) ? $REGISTRY{"Prefix"} : "/opt/novell/xad";
	$PROVISION .= "/sbin/provision";

	if (open(PROVPIPE, "$PROVISION -q --query '$host' |") == 0) {
		print STDERR "Failed to connect to LDAP server on $host\n";
		exit 1;
	}
	while(<PROVPIPE>) {
		chop;
		my ($key, $value) = split(/: /);
		$key =~ s/^(\s+)//g;
		$dcProvInfo{$key} = $value;
	}
	close(PROVPIPE);

	$REGISTRY{"Replication Provider"} = $host; # need canonicalization? 
	$REGISTRY{"Domain GUID"} = $dcProvInfo{"Dom Guid"};
	$REGISTRY{"Domain SID"} = $dcProvInfo{"Dom Sid"};
	$REGISTRY{"Netbios Name"} = $dcProvInfo{"NetBIOS Name"};
	$REGISTRY{"Root Domain"} = $dcProvInfo{"Dom Name"};
	$REGISTRY{"Forest Root"} = $dcProvInfo{"Forest Name"};
	$REGISTRY{"Site"} = $dcProvInfo{"Dc Site Name"};

	validateConfig();

	# re-prime
	registryConfig();
}

1;

