#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# DSfW migrate script for migrating from oes11fp0 to oes11sp1
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2013
#	Novell, Inc.  All rights reserved.
################################################################################
package migration;
$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use strict;
use warnings;

use XAD::registry;
use Logger qw(:DEFAULT);
use File::Copy;
use XAD::nds;
use XAD::registry;
use util;
use util_update;

my $debug =0;
my $lib = registry::getReg("_LIB");

sub enable_config_wizard() {

	my $DCINIT_CONFIG = "/etc/opt/novell/xad/xad.ini";

	copy("/opt/novell/oes-install/util/start-xad-provisioning.desktop",
		"/etc/xdg/autostart/start-xad-config-wizard.desktop");

	#Set this (LAUNCH_CONFIG_WIZARD) variable to 'YES' here
	#This case is applicable only in OES11SP2 migrate case,
	#becasue we need an additional WIZARD to configure
	#Sites and WINS on the DC.
	#This configuration variable will be set to 'NO'
	#once the Sites and WINS configuration completed through WIZARD.
	open(CONFIG,">>$DCINIT_CONFIG") or die("could not open $DCINIT_CONFIG\n");
	my @xad_out = <CONFIG>;
	if (!grep(/LAUNCH_CONFIG_WIZARD\s+=\s+YES/, @xad_out)) {
		print CONFIG "LAUNCH_CONFIG_WIZARD = YES\n";
	}
	close CONFIG;
}

sub migrate2_oes11sp2 ($) {
	my $eDirVersion = shift;
	my $rc = 0;

	# Script to migrate the target server to OES11SP2 level
	Log ("Now starting DSfW server migrate to OES11SP2");

	registry::clearReg();
	registry::reg_init();

	Log ("Reloaded the registry");

	migration::prepare_named($eDirVersion);

	# This needs to be done only in migration of OES2 or OES11/SP1 to OES11SP2,
	# we are reverting ndsd log, back to original log file
	# (/var/opt/novell/eDirectory/log/ndsd.log)
	util::refresh_nldap_server();
	util_update::update_ndsd_log_location();
	util_update::update_gplink_attribute();
	util_update::update_dnipupdate_policy();

	#Configuring NTLM
	#nds::configure_nmas_spnego_method();
	#nds::trigger_backlinker();

	#TODO - if any additional stuffs needed for migrate to OES11SP2
	&enable_config_wizard();

	#BUG 830989 User who is member of Group Policy Creater Owners
	#group only, can't create new GPO
	util_update::changeACLonsysvoldir();
	util_update::changeACLofUserinGPCO("migration");

	# Bug 853613
	util_update::update_acls_on_computer_objects("migration");

	#Updating the winbind run script and smb.conf
	util_update::update_smbconf();
	util_update::update_crontabentries();

	Log ("Successfully migrated the DSfW server to OES11SP2");
}
1;
