#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# DSfW Upgrade script for migrating to oes2015
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2014
#	Novell, Inc.  All rights reserved.
################################################################################
package migration;
$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use strict;
use warnings;
use XAD::registry;
use Logger qw(:DEFAULT);
use File::Copy;
use XAD::nds;
use XAD::registry;
use util;
use util_update;
use Config::IniFiles;

my $debug = 0;
my $lib = registry::getReg("_LIB");
my $LDAP_ERR_DUP = 20;

sub migrate2_oes2015 ($) {
	my $eDirVersion = shift;
	my $rc = 0;

	# Script to migrate the target server to OES2015 level
	Log ("Now starting DSfW server migrate to OES2015");

	registry::clearReg();
	registry::reg_init();

	Log ("Reloaded the registry");

	migration::prepare_named($eDirVersion);

	eval {
		#Adding new acls for third party integrations
		util_update::update_oes2015_acls ();
	};

	if($@){
		Log(WARN, $@);
	}

	#[netlogon] share related changes
	util_update::netlogon_share_changes();
}
1;
