#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# DSfW Upgrade script for migrating to oes2015
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2014
#	Novell, Inc.  All rights reserved.
################################################################################
package migration;
$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use strict;
use warnings;
use XAD::registry;
use Logger qw(:DEFAULT);
use File::Copy;
use XAD::nds;
use XAD::registry;
use util;
use util_update;
use Config::IniFiles;
use NDS::stage;

my $debug = 0;
my $lib = registry::getReg("_LIB");
my $LDAP_ERR_DUP = 20;

sub create_krb5_conf_link(){
	my $krb5_path = registry::getReg("LIVE_ETCDIR");
	if(-f $krb5_path."/krb5.conf"){
		eval{
			if(not -l "/etc/krb5.conf"){
				`rm /etc/krb5.conf`;
			}

			symlink($krb5_path."/krb5.conf", "/etc/krb5.conf");
		};

		if($@) {
			Log(ERR,$@);
		}
	}
}

sub migrate2_oes2018 ($) {
	my $eDirVersion = shift;
	my $rc = 0;
	my $stagedir = registry::getReg("STAGEDIR");

	# Script to migrate the target server to OES2018 level
	Log ("Now starting DSfW server migrate to OES2018");

	registry::clearReg();
	registry::reg_init();

	Log ("Reloaded the registry");

	migration::prepare_named($eDirVersion);

	#create a link to krb5.conf
	create_krb5_conf_link();

	#Adding winbindd service to nsswitch.conf
	util::update_nsswitch();

	#At later point of time, move this code to common migrate location
	Log ("Restarting Firewall");
	`SuSEfirewall2 stop`;
	`SuSEfirewall2 start`;

	eval {
		#Start the ndsd service
		util::stop_ndsd();
		util::start_ndsd();

		util_update::update_server_to2012("MIGRATE");
		util_update::update_for_win10();
		util_update::software_installation_acl();
	};

	if($@){
		Log(WARN, $@);
	}
}
1;
