#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# DSfW Upgrade script for migrating to OES2018SP2
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2020-2021
#	Micro Focus or one of its affiliates.
################################################################################
package migration;
$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use strict;
use warnings;
use XAD::registry;
use Logger qw(:DEFAULT);
use File::Copy;
use XAD::registry;
use util;
use util_update;
use Config::IniFiles;
use NDS::stage;

sub migrate2_oes2018sp3 ($) {
	my $eDirVersion = shift;

	# Script to migrate the target server to OES2018SP3 level
	Log ("Now starting DSfW server migrate to OES2018SP3");

	registry::clearReg();
	registry::reg_init();

	Log ("Reloaded the registry");

	migration::prepare_named($eDirVersion);

	eval {

		# To update wins parameter in smb.conf file.	
		util_update::update_wins_parameter_smb_conf();

		# To remove authprov variable from chrony.conf file.
                util::remove_authprov_in_ntp_conf_file();
	};

	if($@){
		Log(WARN, $@);
	}
}
1;
