#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# DSfW Upgrade script for migrating to OES2023SP11
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2020-2021
#	Micro Focus or one of its affiliates.
################################################################################
package migration;
$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use strict;
use warnings;
use XAD::registry;
use Logger qw(:DEFAULT);
use File::Copy;
use XAD::registry;
use util;
use util_update;
use Config::IniFiles;
use NDS::stage;

sub migrate2_oes2023sp1 ($) {
	my $eDirVersion = shift;

	# Script to migrate the target server to OES2023SP1 level
	Log ("Now starting DSfW server migrate to OES23.4");

	registry::clearReg();
	registry::reg_init();

	Log ("Reloaded the registry");

	migration::prepare_named($eDirVersion);

	eval {

		#To update nmas methods
		util::update_nmas_methods();
		util::retry_trigger_backlinker();

		# To restore firewall
		util::restore_firewall();
		
		# Updating crontab for siteandsubnet script.
		util::update_crontab_sitesandsubnets_string();

		# To update the entry from ntpd to chronyd in w32tm_client.service file.
		util::update_w32tm_client_service();

		# Retrieve latest samba apparmor profile files.
		util::retrieve_latest_samba_apparmor_profile();

		# To update smb.conf file.
		util::update_parameters_in_smb_conf();

	};

	if($@){
		Log(WARN, $@);
	}
}
1;
