#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# DSfW Upgrade script for upgrading from oes11fp0 to oes11sp1
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2013
#	Novell, Inc.  All rights reserved.
################################################################################
package upgrade2oes11sp2;
$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use strict;
use warnings;

use Logger qw(:DEFAULT);
use File::Copy;
use XAD::registry;
use util;
use util_update;

sub enable_config_wizard() {

	my $DCINIT_CONFIG = "/etc/opt/novell/xad/xad.ini";

	copy("/opt/novell/oes-install/util/start-xad-provisioning.desktop",
		"/etc/xdg/autostart/start-xad-config-wizard.desktop");
	
	#Set this (LAUNCH_CONFIG_WIZARD) to 'YES' here
	#This case is applicable only in OES11SP2 upgrade case,
	#becasue we need an additional WIZARD to configure
	#Sites and WINS on the DC.
	#This configuration variable will be set to 'NO'
	#once the Sites and WINS configuration completed through WIZARD.
	Log("Setting 'LAUNCH_CONFIG_WIZARD' variable to 'YES' while upgrading to OES11SP2");
	open(CONFIG,">>$DCINIT_CONFIG") || die("could not open $DCINIT_CONFIG\n");
	my @xad_out = <CONFIG>;
	if (!grep(/LAUNCH_CONFIG_WIZARD\s+=\s+YES/, @xad_out)) {
		print CONFIG "LAUNCH_CONFIG_WIZARD = YES\n";
	}
	close CONFIG;
}

sub upgrade_oes11sp2 () {

	Logger::set_filename("/var/opt/novell/xad/log/ndsdcinit.log");
	Log("Starting DSfW server upgrade to OES11SP2");
	util::refresh_nldap_server();


	#Updating the winbind run script and smb.conf
	util_update::update_smbconf();

	#BUG 830989 User who is member of Group Policy Creater Owners
	#group only, can't create new GPO
	util_update::changeACLonsysvoldir();
	util_update::changeACLofUserinGPCO("upgrade");

	# This needs to be done only in upgrade of OES2/OES11/SP1 to OES11SP2+,
	# we are reverting ndsd log, back to original log file
	# (/var/opt/novell/eDirectory/log/ndsd.log)
	util_update::update_ndsd_log_location();
	util_update::update_gplink_attribute();
	util_update::update_dnipupdate_policy();
	util_update::update_crontabentries();

	# Bug 853613
	util_update::update_acls_on_computer_objects("upgrade");

	&enable_config_wizard();

	Log ("Successfully upgraded the DSfW server to OES11SP2");
}
1;
