#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# DSfW Upgrade script for upgrading from oes11sp2 to oes2015
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2014
#	Novell, Inc.  All rights reserved.
################################################################################
package upgrade2oes2015;
$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use strict;
use warnings;
use XAD::registry;
use Logger qw(:DEFAULT);
use File::Copy;
use File::Temp;
use NDS::stage;
use File::Path;
use util;
use util_update;
use Config::IniFiles;

my $debug = 0;
my $lib = registry::getReg("_LIB");
my $LDAP_ERR_DUP = 20;

sub upgrade_oes2015 () {

	Logger::set_filename("/var/opt/novell/xad/log/ndsdcinit.log");
	Log("Starting DSfW server upgrade to OES2015");

	eval {
		#Adding new acls for third party integrations
		util_update::update_oes2015_acls ();
	};

	if($@){
		Log(WARN, $@);
	}
	#[netlogon] share related changes
	util_update::netlogon_share_changes();
}
1;
