#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# DSfW Upgrade script for upgrading from oes11sp2 to oes2015
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2014
#	Novell, Inc.  All rights reserved.
################################################################################
package upgrade2oes2018;
$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use strict;
use warnings;
use XAD::registry;
use Logger qw(:DEFAULT);
use File::Temp;
use NDS::stage;
use File::Path;
use util;
use util_update;
use Config::IniFiles;
use XAD::schema;
use NDS::import;
use XAD::secure;

sub upgrade_oes2018() {
	Logger::set_filename("/var/opt/novell/xad/log/ndsdcinit.log");
	Log("Starting DSfW server upgrade to OES2018");

	eval {
		#Adding new acls for third party integrations
		util_update::update_server_to2012("UPGRADE");
		util_update::update_for_win10();
		util_update::update_max_smbd_param();
		util_update::software_installation_acl();
	};

	if($@){
		Log(WARN, $@);
	}
}
1;
