#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# DSfW Upgrade script for upgrading from OES11/2015 to OES2018SP3
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2018-2020
#	Micro Focus or one of its affiliates
################################################################################
package upgrade2oes2018sp3;
$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use strict;
use warnings;
use XAD::registry;
use Logger qw(:DEFAULT);
use util;
use util_update;

sub upgrade_oes2018sp3() {
	Logger::set_filename("/var/opt/novell/xad/log/ndsdcinit.log");
	Log("Starting DSfW server upgrade to OES2018SP3");

	eval {
		# Retrieve smb.conf backup file
		util::retrieve_smb_conf_backup();
		util_update::update_max_smbd_param();

		# To update wins parameter in smb.conf file.
                util_update::update_wins_parameter_smb_conf();

		# To remove authprov variable from chrony.conf file.
		util::remove_authprov_in_ntp_conf_file();
		
		# updating the server to 2019 AD schema level
		util_update::update_server_to2019("UPGRADE");
	};

	if($@){
		Log(WARN, $@);
	}
}
1;
