#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# DSfW Upgrade script for upgrading from OES11/2015 to OES2023
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2018-2020
#	Micro Focus or one of its affiliates
################################################################################
package upgrade2oes2023;
$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use strict;
use warnings;
use XAD::registry;
use Logger qw(:DEFAULT);
use util;
use util_update;

sub upgrade_oes2023() {
	Logger::set_filename("/var/opt/novell/xad/log/ndsdcinit.log");
	Log("Starting DSfW server upgrade to OES2023");

	eval {
		# Retrieve smb.conf backup file
		util::retrieve_smb_conf_backup();
		util_update::update_max_smbd_param();

		# Updating chrony.conf file with ntp.conf file.
		util::ntp_to_chrony_conf();

		# Retrieve sysconfig/xad file.
		util::retrieve_xad_sysconfig();

		# Updating crontab for siteandsubnet script.
		util::update_crontab_sitesandsubnets_string();

	};

	if($@){
		Log(WARN, $@);
	}
}
1;
