#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# DSfW Upgrade script for upgrading from OES11/2015 to OES2023SP1
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2018-2020
#	Micro Focus or one of its affiliates
################################################################################
package upgrade2oes2023sp1;
$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use strict;
use warnings;
use XAD::registry;
use Logger qw(:DEFAULT);
use util;
use util_update;

sub upgrade_oes2023sp1() {
	Logger::set_filename("/var/opt/novell/xad/log/ndsdcinit.log");
	Log("Starting DSfW server upgrade to OES23.4");

	eval {

		my $upgrade_from = registry::getReg("UPGRADE_FROM");

		# The condition to retrieve dsfw specific smb.conf file from smb.conf.oes2018-upgrade-save when the server is upgrading from oes2023.
		if ($upgrade_from eq "oes2023"){
			util::retrieve_smb_conf();
		}

		# Update rpc path for chrony
		util::rpc_path_chrony();

		# To update the entry from ntpd to chronyd in w32tm_client.service file.
		util::update_w32tm_client_service();

		# Retrieve latest samba apparmor profile files.
		#util::retrieve_latest_samba_apparmor_profile();

		# To update smb.conf file.
		util::update_parameters_in_smb_conf();

	};

	if($@){
		Log(WARN, $@);
	}
}
1;
