#!/bin/sh
################################################################################
# Domain services for Windows tool for provisioning operations
# Verify the supported server versions in the tree root during YaST install
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2006-2009
#	Novell, Inc.  All rights reserved.
################################################################################

# This script syncs all the password policies with NMAS

GPOTOOL="/opt/novell/xad/sbin/gpo2nmas -q -g"
export LDAPCONF=/etc/opt/novell/xad/openldap/ldap.conf


doma=`(ldapsearch -Y EXTERNAL -b "" -s base -LLL 2>&1) | grep -iw defaultnamingcontext | awk -F: '{print $2}' | tr -d [:space:]`
test -z "$doma" && exit

gPolicies=$(ldapsearch -Y EXTERNAL -b "cn=policies,cn=system,$doma" -s one 2>&1 | grep dn: | awk -F, '{print $1}' | awk -F= '{print $2}')
test -z "$gPolicies" && exit

echo "The list of Group Policies present in the domain $doma are:"
for s in $gPolicies; do
	echo -e "\t$s"
done
echo

for s in $gPolicies; do
	echo "Syncing $s Group Policy"
	$GPOTOOL "$s"
	echo -e "\n"
done
