#!/bin/sh

################################################################################
# Domain services for Windows tool for provisioning operations
# Invokes the java based plugin utility for provisioning the Domain Services
# for windows.
# 
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2006-2008
#	Novell, Inc.  All rights reserved.
################################################################################

#Only root can run the script
if [ $(id -u) -ne 0 ]; then
	echo "DSfW Provisioning Wizard should be only started as root user" 2>&1
	exit 1
fi

# Switch to IBM Java
update-alternatives --set java /usr/lib64/jvm/jre-1.8.0-ibm/bin/java

# YaST passes "ncurses" as the first argument in ncurses mode
# DISPLAY is not defined in terminal / non-graphical mode
if [ "X$1" == "Xncurses" -o "X$DISPLAY" == "X" ]
then
	export TEXTDOMAIN=provision_dsfw
	export TEXTDOMAINDIR=/opt/novell/xad/share/locale
        clear >&2
	error_header=`gettext -s "Error:"`;
	error_msg=`gettext -s "DSfW Provisioning Wizard requires access to a graphical environment."`;
        /usr/bin/dialog --title "$error_header" --msgbox "$error_msg" 10 50 >&2
        clear >&2
        exit 1
fi

export CLASSPATH=/usr/share/java/ldap.jar:/usr/share/java/log4j12/log4j-1.2.15.jar:/usr/share/java/swing-layout.jar:/opt/novell/xad/lib/plugin/ProvisioningPlugin.jar:$CLASSPATH

/usr/lib64/jvm/jre-ibm/bin/java com.novell.oes.dsfw.provisioning.base.ProvisioningPluginMain

# Revert back to default Java
update-alternatives --auto java
