#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl

push(@INC, "/opt/novell/xad/lib64/perl", "/opt/novell/xad/lib/perl");

use XAD::dnsrecords;
use File::Basename;
use strict;
use warnings;

my ($Action, $Filename, $rc, $DnsZoneContext, $Is_ADC) = "";
$Filename = $ARGV[0];
$DnsZoneContext = $ARGV[1];
$Is_ADC = $ARGV[2];
$Action = $ARGV[3];

my $debug = 0;

$rc = Process_DNS_Files($Action, $Filename, $DnsZoneContext, $Is_ADC);


sub Process_DNS_Files {
	my ($Action, $Filename, $FWDZONE_CONTEXT, $Is_ADC) = @_;
	my ($ReadLine, $TempLine, $InstallMachineName, $IPAddress) = "";
	my $IPFlg = 0;
	open(Filename, $Filename) || die "Cannot open $Filename";
	print "Reading from $Filename to process DNS records" if $debug;
	$InstallMachineName = `/opt/novell/xad/share/dcinit/printConfigKey.pl "InstallMachineName" | tr "[:upper:]" "[:lower:]"`;
	chomp $InstallMachineName;
	$IPAddress = `/opt/novell/xad/share/dcinit/printConfigKey.pl "IP Address"`;
	chomp $IPAddress;
	my $File_IP = basename($Filename, ".zone");
	if($File_IP eq $IPAddress)
	{
		# set the IPFlg, used for reverse lookup zone record creation
		$IPFlg = 1;
	}
	print "\n IP flag : $IPFlg\n" if $debug;
	
	while($ReadLine = <Filename>)
	{
		chomp $ReadLine ;
		# leave all the comments starting with ;
		if(!($ReadLine =~ /^\;/))
		{
			$TempLine = $ReadLine;
			$TempLine =~ s/\s+//g;
			if($ReadLine =~ /^_/)
			{
				# a SRV record found, process it;
				dns::Process_RR($ReadLine, $IPFlg, $FWDZONE_CONTEXT, $Is_ADC, $Action);
			}
			if($TempLine =~ /^$InstallMachineName/)
			{
				# A record found,
				# process it
				dns::Process_RR($ReadLine, $IPFlg, $FWDZONE_CONTEXT, $Is_ADC, $Action);
			}
			if(($ReadLine =~ /IN A/) && (!($TempLine =~ /^$InstallMachineName/)))
			{
				# A record found
				# process it
				dns::Process_RR($ReadLine, $IPFlg, $FWDZONE_CONTEXT, $Is_ADC, $Action);
			}
			if($ReadLine =~ /IN CNAME/)
			{
				# CNAME record found, process it
				dns::Process_RR($ReadLine, $IPFlg, $FWDZONE_CONTEXT, $Is_ADC, $Action);
			}
			if($ReadLine =~ /IN NS/)
			{
				# NS record found, process it
				dns::Process_RR($ReadLine, $IPFlg, $FWDZONE_CONTEXT, $Is_ADC, $Action);
			}
			if($ReadLine =~ /IN PTR/)
			{
				# PTR record found, process it
				dns::Process_RR($ReadLine, $IPFlg, $FWDZONE_CONTEXT, $Is_ADC, $Action);
			}
				# other records, not to be processed
		}
	}
	close(Filename);
}
