#!/usr/bin/perl -I/opt/novell/xad/lib/perl -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib64/perl/XAD
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2012
#       Novell, Inc.  All rights reserved.
################################################################################
use strict;
use warnings;

$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use Getopt::Long;
use checkdupws;


sub main
{
	my $is_help = 0;
	my $result = GetOptions ('help' => \$checkdupws::help,
				 'init' => \$checkdupws::initialize,
				 'current' => \$checkdupws::current,
				 'history' => \$checkdupws::history,
				 'schedule=s' => \$checkdupws::schedule,
				 'remove-schedule' => \$checkdupws::unschedule,
				 'debug' => \$checkdupws::is_debug,
				 'clear-cache'    => \$checkdupws::clear_cache) or checkdupws::Usage();
	my $returnValue = -1;

	if ($result != 1) {
		$returnValue = checkdupws::Usage();
		exit($returnValue);
	}

	if ($is_help) {
		$returnValue = checkdupws::Usage();
		exit($returnValue);
	}

	$returnValue = checkdupws::checkDuplicateWorkStation(checkdupws::XAD_CONSOLE);

	exit($returnValue);
}
main;
