#!/usr/bin/perl -I/opt/novell/xad/lib/perl -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib64/perl/XAD
################################################################################
# Domain Services for Windows - WINS configuration tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2012
#       Novell, Inc.  All rights reserved.
################################################################################
use strict;
use warnings;

use Getopt::Long;
use wins_common;

#Following tasks are performed to configure the server as WINS
#1. The DNS entry is created in the corresponding zone object.
#2. The samba file /etc/samba/smb.conf is updated with the variables required for samba services to act as WINS server.
#3. The nmb process is restarted.
#4. The post-check operation for the task checks if the DNS entry and data files corresponding to WINS are created.
sub main
{
	my $is_help = 0;
	my $result = GetOptions ('help' => \$is_help,
		'isconfigured'	=> \$wins_common::is_configured,
		'isconfigured-upgrade'	=> \$wins_common::is_configured_upgrade,
		'onlyconfigure' => \$wins_common::only_configure,
		'postcheck'	=> \$wins_common::only_postcheck,
		'debug'		=> \$wins_common::is_debug) or wins_common::ConfigureUsage();

	$wins_common::environment = wins_common::XAD_CONSOLE;

	my $returnValue = -1;

	if($result != 1)
	{
		$returnValue = wins_common::ConfigureUsage();
		exit($returnValue);
	}

	if($is_help)
	{
		$returnValue = wins_common::ConfigureUsage();
		exit($returnValue);
	}

	$returnValue = wins_common::ConfigureWINS();

	exit($returnValue);
}

main
