#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2004
#	Novell, Inc.  All rights reserved.
################################################################################

push(@INC, "/opt/novell/xad/lib64/perl", "/opt/novell/xad/lib/perl");

use XAD::registry;
use XAD::dclib;

sub genGCConfigInfo
{
# Read template
	my ($host) = @_;
	my %dcProvInfo;
	my $PROVISION;
	my $key;
	my $gcRid = 5; # next available syncrepl RID after LinkEngine
	my $PASCONF;
	my $pasData;

	$PROVISION = $XAD::REGISTRY{"Prefix"};
	$PROVISION .= "/sbin/provision";

	while(<STDIN>) {
		push @GC_CONFIG, $_;
	}

	if (open(PROVPIPE, "$PROVISION -q --list-gc-cross-refs '$host' |") == 0) {
		print STDERR "Failed to connect to LDAP server on $host\n";
		exit 2;
	}

	while(<PROVPIPE>) { 
		chop;
		my ($key, $value) = split(/ /);
		$key =~ s/^(\s+)//g;
		$dcProvInfo{$key} = $value;
	}

	close(PROVPIPE);

	foreach $key (keys %dcProvInfo) {
		$XAD::REGISTRY{"GC Master"} = $key;
		$XAD::REGISTRY{"GC DNS Root"} = $key;
		$XAD::REGISTRY{"GC Domain"} = $dcProvInfo{$key};
		$XAD::REGISTRY{"GC Rid"} = $gcRid++;
		$XAD::REGISTRY{"GC LinkEngine Rid"} = $gcRid++;
		$XAD::REGISTRY{"GC LinkEngine NC"} = "ou=" .
			$XAD::REGISTRY{"GC DNS Root"} .
			",ou=Links," .
			$XAD::REGISTRY{"LinkEngine NC"};

		foreach $_ (@GC_CONFIG) {
			print XAD::regSubstitute($_);
		}

		undef($XAD::REGISTRY{"GC Master"});
		undef($XAD::REGISTRY{"GC DNS Root"});
		undef($XAD::REGISTRY{"GC Domain"});
		undef($$XAD::REGISTRY{"GC Rid"});
		undef($$XAD::REGISTRY{"GC LinkEngine Rid"});
		undef($$XAD::REGISTRY{"GC LinkEngine NC"});
	}
}

if ($#ARGV != 0) {
	print STDERR "Usage: genGCConfig.pl [host] < [template]\n";
	exit 1;
}

&genGCConfigInfo($ARGV[0]);

