#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2004
#	Novell, Inc.  All rights reserved.
################################################################################

#push(@INC, "/opt/novell/xad/lib64/perl", "/opt/novell/xad/lib/perl");

use XAD::ntds;
use POSIX;     # for setlocale()
use Locale::gettext;

setlocale(LC_MESSAGES, "");
bindtextdomain("xad", "/opt/novell/xad/share/locale");
textdomain("xad");

if ($#ARGV < 1) {
	print STDERR <<EOL
Usage:
	genLdif.pl [filename] [--offline] [--section1] ... [--sectionN]
Examples:
	genLdif.pl /opt/novell/xad/share/dcinit/templates/schema.ini --schema
	genLdif.pl /opt/novell/xad/share/dcinit/templates/config.ini --defaultconfignc
	genLdif.pl /opt/novell/xad/share/dcinit/templates/domain.ini --defaultrootdomain
EOL
;
	exit 1;
}

$fileName = $ARGV[0];

if (!(-f $fileName)) {
	print STDERR sprintf(gettext("Could not open %s."), $fileName), "\n";
	exit 1;
}

shift @ARGV;

if ($ARGV[0] eq "--offline") {
	$OFFLINE = 1;
	shift @ARGV;
} else {
	$OFFLINE = 0;
}

my $arg;

foreach $arg (@ARGV[0..$#ARGV]) {
	my $treeRoot;

	if ($arg =~ /^--/) {
		$treeRoot = uc(substr($arg, 2));
	} else {
		print STDERR sprtinf(gettext("Invalid parameter %s"), $_), "\n";
		exit 1;
	}

	XAD::genDcSkelLdif($fileName, $treeRoot, 0, $OFFLINE);
}

