#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################


$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";
use XAD::registry;
use util;
use Logger qw(:DEFAULT);
use Install::check;

my ($status, $msg) = check::pre_check ("SITECONFIGURATION");
if ($status == 1) {
	Log("Pre-check of Sites and Subnets Passed");

	util::partition_server_object();
	util::update_crontab_sitesandsubnets();

	($status, $msg) = check::post_check ("SITECONFIGURATION");
	Log("Post-check of Sites and Subnets Passed") if ($status);
	Log(ERR, "Post-check of Sites and Subnets Failed:[$msg]") if (!$status);

	`echo "SITESANDSUBNET = YES" >> /etc/opt/novell/xad/xad.ini`;

} else {
	Log(ERR, "Pre-check of Sites and Subnets Failed:[$msg], not proceeding for Sites and Subnets");
}
