#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################

$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use XAD::registry;
use Install::frd_install;
use Install::child_install;
use Logger qw(:DEFAULT);
use Install::check;
#use Install::check_util;

my $type = registry::getReg('INSTALL_TYPE');
my $inst;

if($type eq "frd") {
	$inst = frd_install->new();
}
elsif($type eq "child") {
	$inst = child_install->new();
}

my ($status, $msg) = check::pre_check ("CONFIGOBJECTADDITION");
if ($status == 1) {
	Log("Pre-check of add configuration objects Passed");
	$inst->config_online();

	if ($type eq "frd") {
		$inst->schema_online();
		#Schema Addition (Backlink objects creation) steps
		$inst->forest_bl_online();
		$inst->schema_bl_online();

	} elsif ($type eq "child") {
		#This has to be added only after bringing the schema replica
		#to the local server.
		$inst->set_trustposixoffset();
	}
	#Schema Addition (Backlink objects creation) steps
	$inst->domain_bl_online();
	#adds either config{,-bl}.ldif
	$inst->config_bl_online();

        #For non adc's generate uniquedomainid and set it domain root partition
	$inst->gen_uniqueID();

	($status, $msg) = check::post_check ("CONFIGOBJECTADDITION");
	Log("Post-check of add configuration objects Passed") if ($status);
	Log(ERR, "Post-check of add configuration objects Failed:[$msg]") if (!$status);
} else {
	Log(ERR, "Pre-check of add configuration objects Failed:[$msg], not proceeding for adding configuration objects");	
}
