#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################

#This script does not get called for NEW TREE FIRST SERVER

$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use XAD::registry;
use Install::frd_install;
use Install::child_install;
use Install::adc_install;
use Logger qw(:DEFAULT);
use Install::check;
#use Install::check_util;

#Setting sasl path, required for replica operation
my $_LIB = registry::getReg("_Lib");
$ENV{SASL_PATH} = "/opt/novell/xad/$_LIB/sasl2";

my $type = registry::getReg('INSTALL_TYPE');
my $is_replica = registry::getReg("IS_REPLICA");
my $inst;

if ($is_replica eq "TRUE") {
	$inst = adc_install->new();
}
elsif ($type eq "frd") {
	$inst = frd_install->new();
}
elsif($type eq "child") {
	$inst = child_install->new();
}

my ($status, $msg) = check::pre_check ("ADDDOMAINREPLICA");
if ($status == 1) {
	Log("Pre-check of add domain replica Passed");
	$inst->add_domain_replica();
	($status, $msg) = check::post_check ("ADDDOMAINREPLICA");
	Log("Post-check of add domain replica Passed") if ($status);
	Log(ERR, "Post-check of add domain replica Failed:[$msg]") if (!$status);
} else {
	Log(ERR, "Pre-check of add domain replica Failed:[$msg], not proceeding for adding domain replica");
}
