#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################


$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";
use XAD::registry;
use Install::frd_install;
use Install::child_install;
use Logger qw(:DEFAULT);
use Install::check;
#use Install::check_util;

my $type = registry::getReg('INSTALL_TYPE');
my $inst;
my $mapped = registry::getReg("MAPPED");
if ($type eq "frd") {
    $inst = frd_install->new();
}
else {
    $inst = child_install->new();
}


my ($status, $msg) = check::pre_check ("DOMAINOBJADDITION");
if ($status == 1) {
	Log("Pre-check of add domain objects Passed");
	$inst->domaindns_associate_online();
	$inst->domain_object_modify_online();

	$inst->domain_online();

	if($type eq "frd") {
	    $inst->add_partition_container();
	    $inst->forest_objects_online();
	}
	($status, $msg) = check::post_check ("DOMAINOBJADDITION");
	Log("Post-check of add domain objects Passed") if ($status);
	Log(ERR, "Post-check of add domain objects Failed:[$msg]") if (!$status);
} else {
	Log(ERR, "Pre-check of add domain objects Failed:[$msg], not proceeding for adding domain objects");
}

