#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################

$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use XAD::registry;
use Install::frd_install;
use Install::child_install;
use Install::adc_install;
use Logger qw(:DEFAULT);
use Install::check;
#use Install::check_util;

my $type = registry::getReg('INSTALL_TYPE');
my $is_replica = registry::getReg("IS_REPLICA");
my $inst;

if ($is_replica eq "TRUE") {
	$inst = adc_install->new();

	$inst->configure_nldap_objects();
	$inst->refresh_nldap();

	sleep(40); #Waits for 40 secs after the refresh

	$inst->create_site();

	exit(0);
}
elsif ($type eq "frd") {
	$inst = frd_install->new();
}
elsif($type eq "child") {
	$inst = child_install->new();
}

my ($status, $msg) = check::pre_check ("SLAPICONFIG");
if ($status == 1) {
	Log("Pre-check of SLAPI configuration Passed");
	$inst->configure_nldap_objects();
	$inst->refresh_nldap();
#Log("Checking the status of loaded plugins");
	sleep(40); #Waits for 40 secs after the refresh

	if ($type eq "child") {
		$inst->create_site();
	}

	$inst->validate_loaded_plugin();
	($status, $msg) = check::post_check ("SLAPICONFIG");
	Log("Post-check of SLAPI configuration Passed") if ($status);
	Log(ERR, "Post-check of SLAPI configuration Failed:[$msg]") if (!$status);
} else {
	Log(ERR, "Pre-check of SLAPI configuration Failed:[$msg], not proceeding for SLAPI configuration");
}
