#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################


$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";
use XAD::registry;
use Install::adc_install;
use Logger qw(:DEFAULT);
use Install::check;
#use Install::check_util;

my $is_replica = registry::getReg("IS_REPLICA");
my $inst;

#Setting sasl path, required for domain joining operation
my $_LIB = registry::getReg("_Lib");
$ENV{SASL_PATH} = "/opt/novell/xad/$_LIB/sasl2";

if ($is_replica ne "TRUE") {
    Log(Err, "Can not join domain. This must be called only for additional domain controller installation");
    exit(1);
}

$inst = adc_install->new();

my ($status, $msg) = check::pre_check ("DOMAINJOIN");
if ($status == 1) {
	Log("Pre-check of Domain Join Passed");

	$inst->domain_join();
	$inst->refresh_nldap();

	($status, $msg) = check::post_check ("DOMAINJOIN");
	Log("Post-check of Domain Join Passed") if ($status);
	Log(ERR, "Post-check of Domain Join Failed:[$msg]") if (!$status);
} else {
	Log(ERR, "Pre-check of Domain Join Failed:[$msg], not proceeding for Domain Join");
}
