#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################


$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";
use XAD::registry;
use Install::frd_install;
use Install::child_install;
use Logger qw(:DEFAULT);
use Install::check;
#use Install::check_util;
use util;
use util_update;

my $type = registry::getReg('INSTALL_TYPE');
my $inst;

if ($type eq "frd") {
    $inst = frd_install->new();
}
elsif ($type eq "child") {
    $inst = child_install->new();
    $ENV{KRB5CCNAME} = registry::getReg("KRB5CCNAME_DOMAIN");
}

my ($status, $msg) = check::pre_check ("ENABLELOCALKRB");
if ($status == 1) {
	Log("Pre-check to make enable local KDC Passed");
	$inst->enable_krb5_local_lookup();

	if (registry::getReg("IS_REPLICA") eq "FALSE") {
		$inst->acquire_domain_ticket();
	}

	Log("Enabling AES capabilities.");
	util_update::update_domain_to_aes();

	($status, $msg) = check::post_check ("ENABLELOCALKRB");
	Log("Post-check to enable local KDC Passed") if ($status);
	Log(ERR, "Post-check to enable local KDC Failed:[$msg]") if (!$status);
} else {
	Log(ERR, "Pre-check to make enable local KDC Failed:[$msg], not proceeding for enabling local KDC");
}

