#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################


$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";
use XAD::registry;
use Install::frd_install;
use Install::child_install;
use Logger qw(:DEFAULT);
use Install::check;
#use Install::check_util;

my $type = registry::getReg('INSTALL_TYPE');
my $inst;

my ($status, $msg) = check::pre_check ("MIGRATENKDC");
if ($status == 1) {
	Log("Pre-check of migrate NKDC Passed");
	if ($type eq "frd") {
		$inst = frd_install->new();
	}
	elsif($type eq "child") {
		$inst = child_install->new();
	}

	$inst->migrate_nkdc_realm();
	($status, $msg) = check::post_check ("MIGRATENKDC");
        Log("Post-check of migrate NKDC Passed") if ($status);
        Log(ERR, "Post-check of migrate NKDC Failed:[$msg]") if (!$status);
} else {
	Log(ERR, "Pre-check of migrate NKDC Failed:[$msg], not proceeding for migrate NKDC");
}
