#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################


$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";
use XAD::registry;
use Install::frd_install;
use Install::child_install;
use Logger qw(:DEFAULT);
use Install::check;
#use Install::check_util;
use Install::adc_install;

my $type = registry::getReg('INSTALL_TYPE');
my $is_replica = registry::getReg("IS_REPLICA");
my $inst;
if ($is_replica eq "TRUE") {
	$inst = adc_install->new();
}

my ($status, $msg) = check::pre_check ("SCHEMAPARTITIONCREATION");
if ($status == 1) {
	Log("Pre-check of doing schema partition Passed");
	if ($is_replica eq "TRUE") {
		$inst->add_schema_replica();
	}
	elsif ($type eq "frd") {
		$inst = frd_install->new();
		$inst->create_schema_nc();
	}
	elsif($type eq "child") {
		$inst = child_install->new();
		$inst->add_schema_replica();
	}
	($status, $msg) = check::post_check ("SCHEMAPARTITIONCREATION");
	Log("Post-check of schema partition Passed") if ($status);
	Log(ERR, "Post-check of schema partition Failed:[$msg]") if (!$status);
}
else {
	Log(ERR, "Pre-check of doing schema partition Failed:[$msg], not proceeding for Schema Partition");
}
