#!/usr/bin/perl -I. -I.. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################

$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";

use XAD::registry;
use Install::frd_install;
use Install::child_install;
use Install::adc_install;
use Logger qw(:DEFAULT);
use Install::check;
#use Install::check_util;

my $type = registry::getReg('INSTALL_TYPE');
my $inst;
my $is_replica = registry::getReg('IS_REPLICA');

if ($is_replica eq "TRUE") {
	$inst = adc_install->new();
}
elsif ($type eq "frd") {
	$inst = frd_install->new();
}
elsif ($type eq "child") {
	$inst = child_install->new();
}

my ($status, $msg) = check::pre_check ("SETDEFAULTPASSWORD");
if ($status == 1) {
	Log("Pre-check to set default password Passed");
	if (not defined $ENV{ADM_PASSWD}){
		if (not defined $ENV{ADM_PASSWD_DOMAIN}) {
			Log(ERR, "No valid credentials found");
		}
		$ENV{ADM_PASSWD} = $ENV{ADM_PASSWD_DOMAIN};
	}

	$inst->wait_for_samspm();
	$inst->bootstrap_machine();
	if ($is_replica eq "FALSE" ) {
		$inst->bootstrap_krbtgt();
		$inst->bootstrap_administrator();
	}

	($status, $msg) = check::post_check ("SETDEFAULTPASSWORD");
	Log("Post-check to set default password Passed") if ($status);
	Log(ERR, "Post-check to set default password Failed:[$msg]") if (!$status);
} else {
	Log(ERR, "Pre-check to set default password Failed:[$msg], not proceeding for setting credentials for account");
}
