#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################


$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";
use XAD::registry;
use Logger qw(:DEFAULT);
use Install::check;
use util;
use Install::adc_install;

my $type = registry::getReg('INSTALL_TYPE');
my $is_replica = registry::getReg("IS_REPLICA");
my $is_mapped = int(registry::getReg("MAPPED"));
my $inst;

if ($is_replica eq "TRUE") {
    $inst = adc_install->new();
}

my ($status, $msg) = check::pre_check ("SITECONFIGURATION");
if ($status == 1) {
	Log("Pre-check of Site Configuration Passed");

	#Site related changes
	util::partition_server_object();

	($status, $msg) = check::post_check ("SITECONFIGURATION");

	if ($status) {
		Log("Post-check of Site Configuration Passed");
	}

	if (!$status) {
		Log(ERR, "Post-check of Site Configuration Failed:[$msg]");
	}
}
else {
	Log(ERR, "Pre-check of Site Configuration Failed:[$msg], not proceeding for Site Configuration");
}
