#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################


$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";
use XAD::registry;
use Install::frd_install;
use Logger qw(:DEFAULT);
use Install::check;
#use Install::check_util;

my $type = registry::getReg('INSTALL_TYPE'); 
my $inst ;

if ($type eq "frd") {
    $inst = frd_install->new();
}

my ($status, $msg) = check::pre_check ("STAGING");
if ($status == 1) {
	Log("Pre-check of staging Passed");
	$inst->stage_dir();
	$inst->stage_domainguid();
	$inst->stage_ntp();
	$inst->stage_libldap();
	$inst->stage_rc();
	$inst->stage_linkengine();
	$inst->stage_schema_prepare();
	$inst->schema_aggregate();
	$inst->stage_config();
	$inst->stage_domain();
	$inst->stage_ndsd();
	$inst->stage_krb5();
	$inst->stage_samba();
	$inst->stage_sysvol();
	$inst->stage_gpo();
	$inst->stage_xadsd();
	$inst->stage_to_live();
	($status, $msg) = check::post_check ("STAGING");
	Log("Post-check of staging Passed") if ($status);
	Log(ERR, "Post-check of staging Failed:[$msg]") if (!$status);
} else {
	Log(ERR, "Pre-check of staging Failed:[$msg], not proceeding for staging");
}
