#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################


$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";
my $_LIB = registry::getReg("_Lib");
$ENV{SASL_PATH} = "/opt/novell/xad/$_LIB/sasl2";

use XAD::registry;
use Install::child_install;
use Logger qw(:DEFAULT);
use Install::check;

my $type = registry::getReg('INSTALL_TYPE');
my $parentdomain;
my $inst;

if ($type eq "child") {
    $inst = child_install->new();
}

my ($status, $msg) = check::pre_check ("CREATETRUST");
if ($status == 1) {
	Log("Pre-check to create parent-child trust Passed");

	$parentdomain = registry::getReg("Parent Domain");
	util::send_domain_update_now_signal ($parentdomain);

	#Gets the ticket from the installed domain and store it
	$ENV{KRB5CCNAME} = registry::getReg("KRB5CCNAME_DOMAIN");
	$inst->acquire_domain_ticket();
	$inst->generate_shared_secret_export();
	$inst->remove_trusts();
	$inst->add_trusts();
	$inst->bind_cross_ref();
	($status, $msg) = check::post_check ("CREATETRUST");
	Log("Post-check of parent-child trust Passed") if ($status);
	Log(ERR, "Post-check of parent-child trust Failed:[$msg]") if (!$status);
} else {
	Log(ERR, "Pre-check to create parent-child trust Failed:[$msg], not proceeding for trust creation");
}
