#!/usr/bin/perl -I. -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib/perl
################################################################################
# Domain Services for Windows Provisioning Tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2001-2009
#	Novell, Inc.  All rights reserved.
################################################################################


$ENV{'PATH'} = "/opt/novell/xad/share/dcinit:$ENV{'PATH'}";
use XAD::registry;
use Install::adc_install;
use Logger qw(:DEFAULT);
use Install::check;
#use Install::check_util;

my $is_replica = registry::getReg("IS_REPLICA");
my $inst;
my $check_pre_post = $ARGV[0];
my $task = $ARGV[1];
chomp($task);

#Setting sasl path, required for domain joining operation
my $_LIB = registry::getReg("_Lib");


$ENV{SASL_PATH} = "/opt/novell/xad/$_LIB/sasl2";
if ($check_pre_post eq "post") {
	Log ("Got the task as [$task]");
	my ($status, $msg) = check::post_check("$task");
	Log("Check for $task Passed") if ($status);
    if (!$status) {
	    Log(ERR, "Check for $task Failed:[$msg]");
    }
}


if ($check_pre_post eq "pre") {
	
	my ($status, $msg) = check::pre_check($task);
	Log("Check for $task Passed") if ($status);
    if (!$status) {
	    Log(ERR, "Check for $task Failed:[$msg]");
    }
}

