#!/usr/bin/perl -I/opt/novell/xad/lib/perl -I/opt/novell/xad/lib64/perl -I/opt/novell/xad/lib64/perl/XAD
################################################################################
# Domain Services for Windows - WINS unconfiguration tool
#
# See the file LICENSE for redistribution information.
#
# Copyright (c) 2012
#       Novell, Inc.  All rights reserved.
################################################################################
use strict;
use warnings;

use Getopt::Long;
use wins_common;

sub main
{
	my $is_help = 0;
	my $result = GetOptions ('help' => \$is_help,
				 'postcheck' => \$wins_common::only_postcheck,
				 'debug' => \$wins_common::is_debug);

	$wins_common::environment = wins_common::XAD_CONSOLE;

	my $returnValue = -1;

	if($result != 1)
	{
		$returnValue = wins_common::UnconfigureUsage();
		exit(0);
	}

	if($is_help)
	{
		$returnValue = wins_common::UnconfigureUsage();
		exit(0);
	}

	if($wins_common::only_postcheck == 1)
	{
		$returnValue = wins_common::post_check_WINS();
		exit($returnValue);
	}

	$returnValue = wins_common::UnconfigureWINS();

	exit($returnValue);

}
main;
